/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IItem;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidMacroException;
import cdac.medinfo.sdk.dcm30_04.exceptions.MandatoryMissingException;
import cdac.medinfo.sdk.dcm30_04.exceptions.ValidationException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;
import cdac.medinfo.sdk.dcm30_04.utils.EnumFeatureList;

/**
 * This Macro specifies the Attributes that reference a SOP Instance.
 */

public class SOPInstanceReferenceMacro extends Macro  
{
	
	private static final long serialVersionUID = 1L;

	/**
	 * This constructor constructs a Macro with specified Data Set.
	 * @param objDataSet Collection of Data Elements 
	 */
	public SOPInstanceReferenceMacro(IDataSet objDataSet)
	{
		super(objDataSet);
	}

	/**
	 * This constructor constructs a Macro with specified Data Set and Dictionary Reader
	 * @param objDataSet specifies the DataSet
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used 
	 */
	public SOPInstanceReferenceMacro(IDataSet objDataSet,IDictionaryReader objDictionaryReader)
	{
		super(objDataSet,objDictionaryReader);
	}

	/**
	 * This constructor constructs a Macro with the specified Item
	 * @param objItem specifies instance of Item class
	 */
	public SOPInstanceReferenceMacro(IItem objItem)
	{
		super(objItem);
	}

	/**
	 * This constructor constructs a Macro with the specified Item and DictionaryReader
	 * @param objItem specifies instance of Item class
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used 
	 */
	public SOPInstanceReferenceMacro(IItem objItem,IDictionaryReader objDictionaryReader)
	{
		super(objItem, objDictionaryReader);
	}

	/**
	 * Validates all the attributes in SOPInstanceReferenceMacro
	 * @return boolean - Success -true, Failure -false.
	 * @throws InvalidMacroException throws InvalidMacroException If Mandatory or Conditional element fails.
	 */
	public boolean validate() throws InvalidMacroException
	{
		if(iMacroLevel == DicomConstants.DCM_MODULE_LEVEL_MACRO)
			return validate(objIDataSet);
		return false;
	}

	/**
	 * Validates all the attributes in SOPInstanceReferenceMacro that are present in the DataSet
	 * @param objIDataSet collection of DataElements
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidMacroException throws InvalidMacroException If Mandatory or Conditional element fails.
	 */
	public boolean validate(IDataSet objIDataSet) throws InvalidMacroException
	{
		try{
			if(!objIDataSet.isPresent(0x0008,0x1150))
				throw new MandatoryMissingException("0008,1150");
			else if(!objIDataSet.isPresent(0x0008,0x1115))
				throw new MandatoryMissingException("0008,1115");
			else
				((ReferencedSeriesSequence)objIDataSet.getDataForTag(0x0008,0x1115)).validate();
		}
		catch(MandatoryMissingException mme)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(mme.getMessage());
			}
			throw new InvalidMacroException(this.getClass().getSimpleName(),mme);
		}
		catch( ValidationException ve)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(ve.getMessage());
			}
			throw new InvalidMacroException(this.getClass().getSimpleName(),ve);
		}
		return true;
	}

	/**
	 * Sets The Referenced SOP Class UID which uniquely identifies the refernced SOP Class
	 * Class UID and 0-n optional SOP Class UIDs.
	 * @param strReferencedSOPClassUID String array of SOP Class UID.
	 */
	public void setReferencedSOPClassUID(String strReferencedSOPClassUID)
	{
		/* Accept the SOP Classes Supported of type UI.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0008,0x1150, strReferencedSOPClassUID,objIDictionaryReader);
		else
			objIDataElement = new ExplicitDE(0x0008,0x1150,DicomConstants.DCM_DT_UI, strReferencedSOPClassUID);

		addDataElement(objIDataElement);
	}

	/**
	 * Retrieves The Referenced SOP Class UID which uniquely identifies the refernced SOP Class.
	 * @return String - value of  SOP Classes Supported
	 */
	public String getReferencedSOPClassUID()
	{
		Object objValue = getValue(0x0008,0x1150);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	
	/**
	 * Sets The Referenced SOP Instance UID which uniquely identifies the refernced SOP Class
	 * Instance UID and 0-n optional SOP Class UIDs.
	 * @param strReferencedSOPInstanceUID String array of SOP Instance UID.
	 */
	public void setReferencedSOPInstanceUID(String strReferencedSOPInstanceUID)
	{
		/* Accept the SOP Classes Supported of type UI.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0008,0x1155, strReferencedSOPInstanceUID,objIDictionaryReader);
		else
			objIDataElement = new ExplicitDE(0x0008,0x1155,DicomConstants.DCM_DT_UI, strReferencedSOPInstanceUID);

		addDataElement(objIDataElement);
	}

	/**
	 * Retrieves The Referenced SOP Instance UID which uniquely identifies the referenced SOP Instance.
	 * @return String - value of  SOP Instance UID
	 */
	public String getReferencedSOPInstanceUID()
	{
		Object objValue = getValue(0x0008,0x1155);
		if(objValue != null)
			return objValue.toString();
		return null;
	}

}